/*
 *  Parser.h
 *  ucasm
 *
 *  Created by Dawid Pilawa on 10/25/09.
 *
 */


namespace ucasm {

class Parser {

	Lexer* lexer;
	Microcode* ucode;
	
	token currentToken;
	int currentOpcode;
	int currentLine;
	int currentFlags;
	int flagC, flagZ, flagN, flagV;
	token addressBus;
	int busIfcFieldInUse;
	
	set<int> usedTokens;
	set<int> usedSteps;
	
	void err(const char* msg); 	
	void parseOpcode(ifstream& s);
	void parseLine(ifstream& s);
	void parseFlags(ifstream& s);
	void parseMicroinstructions(ifstream& s, MicrocodeWord& ucword);
	void parseTransfer(ifstream& s, MicrocodeWord& ucword);

	int accept(ifstream& s, token t);
	int expect(ifstream& s, token t);
	int see(ifstream& s, token t);

public:

	Parser(Lexer* l, Microcode* m);
	void Parse(ifstream& s);

};

};
