/*
 *  tokens.h
 *  ucasm
 *
 *  Created by Dawid Pilawa on 10/21/09.
 *
 */

/*******************************************************
 *
 * Tokens returned by microcode lexical analyzer
 *
 *******************************************************/
enum token {
	
	// OP, ENDOP
	OP,
	ENDOP,
	
	// literals
	DECVAL,
	HEXVAL,
	
	// register identifiers
	A,
	X,
	Y,
	MDR,
	PC,
	PPC,	
	DP,
	SP,
	USP,
	MAR,
	IR,
	MSW,
	IPTR,
	MEM,
	
	// byte qualifiers
	HI,
	LO,
	
	// register transfer
	TRANSFER,
	
	// delimiters
	COMMA,
	SEMICOLON,
	LBR,
	RBR,
	
	// arithmetic
	PLUS,
	MINUS,
	INC,
	DEC,
	
	// logic
	AND,
	OR,
	XOR,
	
	// shifter
	SHR,
	
	// flags logic
	ANY,
	NOT,
	C,
	Z,
	N,
	V,
	SETFLAGS_WORD,
	SETFLAGS_HIBYTE,
	SETFLAGS_LOBYTE,
	
	// misc
	FETCH,
	CODE,
	DATA,
	SUPERVISOR,
	ERROR,
	END,
	LATCH_I,
	LATCH_S,
	
	// special
	MINUSONE
};
